from PIL import Image, ImageTk
import PIL
import tkinter as tk
import cv2
import numpy as np
from Farbaenderung import Dyschromasie
from Scrollbar import ScrollFrame

root = tk.Tk()
simGrad = tk.IntVar(root)

root.title("Projekt Dyschromasie")

SB = ScrollFrame(root)

img = np.array([])
rows = 0
cols = 0
kanaele = 0

sim_pro = tk.IntVar(root)
sim_deut = tk.IntVar(root)
sim_tri = tk.IntVar(root)

simulationsGradient = tk.Scale(SB.frame, from_=0, to_=100, variable=simGrad, orient='horizontal')
simulationsGradient.grid(column=0, row=1, columnspan=10)


def browse():
    # Auswahl des FilePaths
    try:
        path = tk.filedialog.askopenfilename(filetypes=[("Image File", '.jpg'), ("Image File", '.png')])
        im = Image.open(path)
    except:
        tk.messagebox.showerror(title='Datenfehler', message='Kein Bild gefunden/ausgewählt')
    global simulateButton
    if len(path) > 0:
        simulateButton.config(state='active')
        daltonButton.config(state='active')

        # Anzeigen des Bildes
        tkimage = ImageTk.PhotoImage(im)
        myvar = tk.Label(SB.frame, image=tkimage)
        myvar.image = tkimage
        myvar.grid(columnspan=5)

        # Einspeichern der Path-Informationen
        global img, rows, cols, kanaele
        img = cv2.imread(path)
        img = cv2.cvtColor(img, cv2.COLOR_BGR2RGB)
        rows, cols, kanaele = img.shape


def showImage(img, rows, cols, kanaele, sim_faktor, sim_kind, sim_art):
    color_blindness = Dyschromasie(img, rows, cols, kanaele, sim_faktor, sim_kind)
    if sim_art == 'Sim':
        color_blindness_mat = np.copy(color_blindness.Simulate()).astype('uint8')
    else:
        color_blindness_mat = np.copy(color_blindness.daltonize()).astype('uint8')

    T = tk.Text(SB.frame, height=1, width=15)
    T.grid(columnspan=5)
    print_string = sim_kind + ' ' + str(round(color_blindness.sim_faktor * 100)) + "%"
    T.insert('current', print_string)

    conv_SimulationPic = ImageTk.PhotoImage(image=PIL.Image.fromarray(color_blindness_mat))
    sim_pic = tk.Label(SB.frame, image=conv_SimulationPic)
    sim_pic.Image = conv_SimulationPic
    sim_pic.grid(columnspan=5)


def simulate():
    global img, rows, cols, kanaele, sim_pro, sim_deut, sim_tri
    if sim_deut.get():
        showImage(img, rows, cols, kanaele, simGrad.get()/100, 'Deuteranop', 'Sim')

    elif sim_tri.get():
        showImage(img, rows, cols, kanaele, simGrad.get() / 100, 'Tritanop', 'Sim')

    elif sim_pro.get():
        showImage(img, rows, cols, kanaele, simGrad.get() / 100, 'Protanop', 'Sim')


def daltonize():
    global img, rows, cols, kanaele, sim_pro, sim_deut, sim_tri
    if sim_deut.get():
        showImage(img, rows, cols, kanaele, simGrad.get()/100, 'Deuteranop', 'Dalt')

    elif sim_tri.get():
        showImage(img, rows, cols, kanaele, simGrad.get() / 100, 'Tritanop', 'Dalt')

    elif sim_pro.get():
        showImage(img, rows, cols, kanaele, simGrad.get() / 100, 'Protanop', 'Dalt')


browseButton = tk.Button(SB.frame, text="Browse", width=25, command=browse, bg='light blue')
browseButton.grid(column=0, row=0, columnspan=1)

simulateButton = tk.Button(SB.frame, text="Simulate", width=25, command=simulate, bg='light blue')
simulateButton.grid(column=1, row=0, columnspan=1)
simulateButton.config(state='disabled')

daltonButton = tk.Button(SB.frame, text="Daltonize", width=25, command=daltonize, bg='light blue')
daltonButton.grid(column=2, row=0, columnspan=1)
daltonButton.config(state='disabled')

checkButton_p = tk.Checkbutton(SB.frame, text="Protanop", variable=sim_pro, onvalue=1, offvalue=0, height=5, width=20)
checkButton_d = tk.Checkbutton(SB.frame, text="Deutanop", variable=sim_deut, onvalue=1, offvalue=0, height=5, width=20)
checkButton_t = tk.Checkbutton(SB.frame, text="Tritanop", variable=sim_tri, onvalue=1, offvalue=0, height=5, width=20)

checkButton_p.grid(column=0, row=2)
checkButton_d.grid(column=1, row=2)
checkButton_t.grid(column=2, row=2)

SB.update()
root.mainloop()
